# Funkcja pomocnicza do zliczania sumy cyfr liczby.
def suma_cyfr(liczba):
  wynik = 0
  while liczba != 0:
    wynik += liczba % 10
    liczba //= 10
  return wynik

def main():
  (N, X) = tuple(map(int, input().split()))
  # Ustawiamy obecny element na X.
  # Wstawiamy dodatkowo element zerowy (aby indeksy się zgadzały).
  A = [0, X]
  # Dodatkowo będziemy utrzymywali słownik indeks, który dla każdego
  # elementu ciągu będzie wskazywał jego pierwsze wystąpienie.
  indeks = {X: 1}
  for i in range(2, N+1):
    # Każdy kolejny element jest dwukrotnością sumy cyfr poprzedniego.
    A.append(2*suma_cyfr(A[-1]))
    # Jeżeli ostatni element ma już wartość w indeks, to znaleźliśmy cykl.
    if A[-1] in indeks.keys():
      # Ustaw początek i koniec ciągu.
      start_cyklu = indeks[A[-1]]
      koniec_cyklu = i
      # Liczymy długość cyklu.
      dlugosc_cyklu = koniec_cyklu - start_cyklu
      # Znajdujemy odpowiednią pozycję N-tego elementu w cyklu.
      indeks_na_cyklu = (N - start_cyklu) % dlugosc_cyklu
      # I wypisujemy odpowiedni element z cyklu.
      print(A[start_cyklu + indeks_na_cyklu])
      return
    # Ustawiamy indeks aktualnego elementu na i.
    indeks[A[-1]] = i
  # Jeżeli nie doszliśmy do ciągu, po prostu wypisz wynik.
  print(A[N])

main()
